package peer

import (
	"github.com/iotaledger/goshimmer/packages/identity"
	"github.com/iotaledger/goshimmer/plugins/autopeering/types/salt"
)

const (
	MARSHALED_PUBLIC_KEY_START   = 0
	MARSHALED_ADDRESS_TYPE_START = MARSHALED_PUBLIC_KEY_END
	MARSHALED_ADDRESS_START      = MARSHALED_ADDRESS_TYPE_END
	MARSHALED_PEERING_PORT_START = MARSHALED_ADDRESS_END
	MARSHALED_GOSSIP_PORT_START  = MARSHALED_PEERING_PORT_END
	MARSHALED_SALT_START         = MARSHALED_GOSSIP_PORT_END

	MARSHALED_PUBLIC_KEY_END   = MARSHALED_PUBLIC_KEY_START + MARSHALED_PUBLIC_KEY_SIZE
	MARSHALED_ADDRESS_TYPE_END = MARSHALED_ADDRESS_TYPE_START + MARSHALED_ADDRESS_TYPE_SIZE
	MARSHALED_ADDRESS_END      = MARSHALED_ADDRESS_START + MARSHALED_ADDRESS_SIZE
	MARSHALED_PEERING_PORT_END = MARSHALED_PEERING_PORT_START + MARSHALED_PEERING_PORT_SIZE
	MARSHALED_GOSSIP_PORT_END  = MARSHALED_GOSSIP_PORT_START + MARSHALED_GOSSIP_PORT_SIZE
	MARSHALED_SALT_END         = MARSHALED_SALT_START + MARSHALED_SALT_SIZE

	MARSHALED_PUBLIC_KEY_SIZE   = identity.PUBLIC_KEY_BYTE_LENGTH
	MARSHALED_ADDRESS_TYPE_SIZE = 1
	MARSHALED_ADDRESS_SIZE      = 16
	MARSHALED_PEERING_PORT_SIZE = 2
	MARSHALED_GOSSIP_PORT_SIZE  = 2
	MARSHALED_SALT_SIZE         = salt.SALT_MARSHALED_SIZE

	MARSHALED_TOTAL_SIZE = MARSHALED_SALT_END
)
